# Rust API client for openapi

This is an auto generated API description made out of an Ent schema definition


## Overview

This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 0.1.0
- Package version: 0.1.0
- Generator version: 7.4.0
- Build package: `org.openapitools.codegen.languages.RustClientCodegen`

## Installation

Put the package under your project folder in a directory named `openapi` and add the following to `Cargo.toml` under `[dependencies]`:

```
openapi = { path = "./openapi" }
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CardApi* | [**create_card**](docs/CardApi.md#create_card) | **POST** /cards | Create a new Card
*CardApi* | [**delete_card**](docs/CardApi.md#delete_card) | **DELETE** /cards/{id} | Deletes a Card by ID
*CardApi* | [**draw_done**](docs/CardApi.md#draw_done) | **PUT** /cards/{id}/d | Draws a card item as done.
*CardApi* | [**draw_start**](docs/CardApi.md#draw_start) | **PATCH** /users/{id}/card/start | Draws a card item as done.
*CardApi* | [**list_card**](docs/CardApi.md#list_card) | **GET** /cards | List Cards
*CardApi* | [**read_card**](docs/CardApi.md#read_card) | **GET** /cards/{id} | Find a Card by ID
*CardApi* | [**read_card_owner**](docs/CardApi.md#read_card_owner) | **GET** /cards/{id}/owner | Find the attached User
*CardApi* | [**update_card**](docs/CardApi.md#update_card) | **PATCH** /cards/{id} | Updates a Card
*GroupApi* | [**create_group**](docs/GroupApi.md#create_group) | **POST** /groups | Create a new Group
*GroupApi* | [**delete_group**](docs/GroupApi.md#delete_group) | **DELETE** /groups/{id} | Deletes a Group by ID
*GroupApi* | [**list_group**](docs/GroupApi.md#list_group) | **GET** /groups | List Groups
*GroupApi* | [**list_group_users**](docs/GroupApi.md#list_group_users) | **GET** /groups/{id}/users | List attached Users
*GroupApi* | [**read_group**](docs/GroupApi.md#read_group) | **GET** /groups/{id} | Find a Group by ID
*GroupApi* | [**update_group**](docs/GroupApi.md#update_group) | **PATCH** /groups/{id} | Updates a Group
*UeApi* | [**create_ue**](docs/UeApi.md#create_ue) | **POST** /ues | Create a new Ue
*UeApi* | [**delete_ue**](docs/UeApi.md#delete_ue) | **DELETE** /ues/{id} | Deletes a Ue by ID
*UeApi* | [**list_ue**](docs/UeApi.md#list_ue) | **GET** /ues | List Ues
*UeApi* | [**read_ue**](docs/UeApi.md#read_ue) | **GET** /ues/{id} | Find a Ue by ID
*UeApi* | [**read_ue_owner**](docs/UeApi.md#read_ue_owner) | **GET** /ues/{id}/owner | Find the attached User
*UeApi* | [**update_ue**](docs/UeApi.md#update_ue) | **PATCH** /ues/{id} | Updates a Ue
*UserApi* | [**create_user**](docs/UserApi.md#create_user) | **POST** /users | Create a new User
*UserApi* | [**delete_user**](docs/UserApi.md#delete_user) | **DELETE** /users/{id} | Deletes a User by ID
*UserApi* | [**list_user**](docs/UserApi.md#list_user) | **GET** /users | List Users
*UserApi* | [**list_user_card**](docs/UserApi.md#list_user_card) | **GET** /users/{id}/card | List attached Cards
*UserApi* | [**list_user_ue**](docs/UserApi.md#list_user_ue) | **GET** /users/{id}/ue | List attached Ues
*UserApi* | [**read_user**](docs/UserApi.md#read_user) | **GET** /users/{id} | Find a User by ID
*UserApi* | [**update_user**](docs/UserApi.md#update_user) | **PATCH** /users/{id} | Updates a User


## Documentation For Models

 - [Card](docs/Card.md)
 - [CardCreate](docs/CardCreate.md)
 - [CardList](docs/CardList.md)
 - [CardOwnerRead](docs/CardOwnerRead.md)
 - [CardRead](docs/CardRead.md)
 - [CardUpdate](docs/CardUpdate.md)
 - [CreateCardRequest](docs/CreateCardRequest.md)
 - [CreateGroupRequest](docs/CreateGroupRequest.md)
 - [CreateUeRequest](docs/CreateUeRequest.md)
 - [CreateUserRequest](docs/CreateUserRequest.md)
 - [Group](docs/Group.md)
 - [GroupCreate](docs/GroupCreate.md)
 - [GroupList](docs/GroupList.md)
 - [GroupRead](docs/GroupRead.md)
 - [GroupUpdate](docs/GroupUpdate.md)
 - [GroupUsersList](docs/GroupUsersList.md)
 - [ListCard400Response](docs/ListCard400Response.md)
 - [Ue](docs/Ue.md)
 - [UeCreate](docs/UeCreate.md)
 - [UeList](docs/UeList.md)
 - [UeOwnerRead](docs/UeOwnerRead.md)
 - [UeRead](docs/UeRead.md)
 - [UeUpdate](docs/UeUpdate.md)
 - [UpdateCardRequest](docs/UpdateCardRequest.md)
 - [UpdateGroupRequest](docs/UpdateGroupRequest.md)
 - [UpdateUeRequest](docs/UpdateUeRequest.md)
 - [UpdateUserRequest](docs/UpdateUserRequest.md)
 - [User](docs/User.md)
 - [UserCardList](docs/UserCardList.md)
 - [UserCreate](docs/UserCreate.md)
 - [UserList](docs/UserList.md)
 - [UserRead](docs/UserRead.md)
 - [UserUeList](docs/UserUeList.md)
 - [UserUpdate](docs/UserUpdate.md)


To get access to the crate's generated documentation, use:

```
cargo doc --open
```

## Author



